<template>
  <div>
    <mt-page-title
      :with-border="false"
      :with-padding="false"
      border-style="padding:1.5rem 0"
      link-text="retour aux groupes"
      :link-to="profilLink({ name: 'pax-groupe' })"
    >
      <h1 class="has-text-weight-bold is-size-3">
        Modifier un groupe
      </h1>
    </mt-page-title>

    <mt-form-groupe
      :utilisateurs-selected="utilisateursSelected"
      :groupe="groupe"
      :utilisateurs="utilisateurs"
      :id-corps="idCorps"
      :autocomplete-data="data"
      :is-fetching="isFetching"
      @submit="modifierGroupe"
      @select-all="viderFiltre"
      @select-categorie="filtreCategorie"
      @typing="getAsyncData"
      @select="selectAutoComplete"
      @ajouter="ajouter"
      @delete="supprimer"
      @selectionner-all-user="selectionnerAll"
    >
      <div class="columns">
        <div class="control column">
          <nuxt-link :to="profilLink({ name: 'pax-groupe' })" class="button is-secondary mt-button is-size-8 ">
            annuler
          </nuxt-link>
        </div>
        <div class="control column">
          <b-button
            class="mt-button is-size-8 has-text-weight-semibold"
            type="is-primary"
            native-type="submit"
            :disabled="!groupe.nom"
          >
            Enregistrer les modifications
          </b-button>
        </div>
        <div class="control column">
          <b-button
            class="mt-button is-size-8 has-text-weight-semibold"
            type="is-secondary"
            icon-left="delete"
            @click="ouvertPopUpSupprimer = true"
          >
            Supprimer
          </b-button>
        </div>
      </div>
    </mt-form-groupe>
    <mt-modal-ok :ouvert.sync="ouvert" @action="retourGroupe">
      Le groupe a bien été modifié.
    </mt-modal-ok>
    <mt-modal-action type-delete :ouvert.sync="ouvertPopUpSupprimer" @action="supprimerGroupe">
      Etes vous sur de vouloir supprimer ce groupe ?
    </mt-modal-action>
    <mt-modal-ok :ouvert.sync="ouvertPopUpConfirmationSuppression" @action="retourGroupe">
      Le groupe a bien été supprimé.
    </mt-modal-ok>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtModalOk from '~/components/modal/mt-modal-ok';
import userMixin from '~/components/mixins/userMixin';
import MtFormGroupe from '~/components/pax/groupe/form-groupe';
import { groupePersonnaliserMixin } from '~/components/mixins/groupePersonnaliserMixin';
import MtModalAction from '~/components/modal/mt-modal-action';

export default {
  layout: 'container-small',
  components: {
    MtModalAction,
    MtFormGroupe,
    MtPageTitle,
    MtModalOk,
  },
  mixins: [userMixin, groupePersonnaliserMixin],
  data() {
    return {
      ouvertPopUpSupprimer: false,
      ouvertPopUpConfirmationSuppression: false,
    };
  },
  async asyncData({ $api, params }) {
    const [utilisateurs, groupe] = await Promise.all([
      $api.organisme().utilisateursFilterWithNoEnabled(),
      $api.groupePersonnaliser.get(params.id),
    ]);
    const utilisateursSelected = groupe.groupesPersonnaliserDetails.map((value) => value.utilisateur);
    const idGroupePersonnaliser = params.id;
    return {
      utilisateurs,
      groupe,
      utilisateursSelected,
      idGroupePersonnaliser,
    };
  },
  methods: {
    async supprimerGroupe() {
      await this.$api.groupePersonnaliser.delete(this.groupe.id);
      this.ouvertPopUpSupprimer = false;
      this.ouvertPopUpConfirmationSuppression = true;
    },
    async modifierGroupe() {
      try {
        this.groupe.proprietaire = this.utilisateur;
        this.groupe.groupesPersonnaliserDetails = [];
        this.utilisateursSelected.forEach((utilisateur) => {
          this.groupe.groupesPersonnaliserDetails.push({ utilisateur });
        });
        await this.$api.groupePersonnaliser.put(this.idGroupePersonnaliser, this.groupe);
        this.ouvert = true;
      } catch ({ response: { status }, data: { message } }) {
        this.$buefy.toast.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

/deep/ .mt-list-item {
  display: flex;
  align-items: center;
}

.mt-nom-prenom {
  flex-grow: 1;
}

/deep/ .mt-filter-liste {
  & > article {
    margin-left: 0.75em;
  }
}
.margin {
  margin: 1rem 0;
}
.is-selected {
  color: #dfdfdf;

  &.mt-list-item-selected {
    color: $soft-blue;
  }
}
</style>
